Index: trunk/src/world_entities/npcs/npc_test.cc
===================================================================
--- trunk/src/world_entities/npcs/npc_test.cc	(revision 9110)
+++ trunk/src/world_entities/npcs/npc_test.cc	(revision 9235)
@@ -23,12 +23,15 @@
 #include "shader.h"
 #include "state.h"
-#include "stdlibincl.h"
 #include "debug.h"
 
+#include "loading/factory.h"
+#include "loading/load_param.h"
 
-using namespace std;
+#include "effects/explosion.h"
+
+CREATE_FACTORY(NPC2, CL_NPC_TEST2);
 
 
-NPC2::NPC2()
+NPC2::NPC2(const TiXmlElement* root)
   : NPC(NULL)
 {
@@ -36,7 +39,10 @@
 
   if ((float)rand()/RAND_MAX > .5f)
-    this->loadModel("models/ships/bolido.obj", 3);
+    this->loadModel("models/ships/bolido.obj", 6);
   else
-    this->loadModel("models/ships/gobblin.obj", 3);
+    this->loadModel("models/ships/gobblin.obj", 6);
+
+
+
 
   this->shader = NULL;
@@ -44,7 +50,8 @@
     this->shader = Shader::getShader("shaders/toon.vert", "shaders/toon.frag");
 
-  this->obj = gluNewQuadric();
+  this->randomRotAxis = VECTOR_RAND(1);
 
-  this->randomRotAxis = VECTOR_RAND(1);
+  if (root != NULL)
+    this->loadParams(root);
 }
 
@@ -54,5 +61,19 @@
   if (this->shader)
     Shader::unload(this->shader);
-  gluDeleteQuadric(this->obj);
+}
+
+
+void NPC2::loadParams(const TiXmlElement* root)
+{
+  NPC::loadParams(root);
+
+}
+
+
+void NPC2::destroy(WorldEntity* killer)
+{
+  Explosion::explode(this, Vector(10,10,10));
+  this->toList(OM_DEAD);
+
 }
 
@@ -67,25 +88,26 @@
 void NPC2::draw() const
 {
-//   glMatrixMode(GL_MODELVIEW);
-//   glPushMatrix();
-//   float matrix[4][4];
-//
-//   /* translate */
-//   glTranslatef (this->getAbsCoor ().x,
-//                 this->getAbsCoor ().y,
-//                 this->getAbsCoor ().z);
-//   /* rotate */
-//   this->getAbsDir ().matrix (matrix);
-//   glMultMatrixf((float*)matrix);
-//
+  glMatrixMode(GL_MODELVIEW);
+  glPushMatrix();
+  float matrix[4][4];
+
+  /* translate */
+  glTranslatef (this->getAbsCoor ().x,
+                this->getAbsCoor ().y,
+                this->getAbsCoor ().z);
+  /* rotate */
+  this->getAbsDir ().matrix (matrix);
+  glMultMatrixf((float*)matrix);
+
 //   if (this->shader != NULL && this->shader != Shader::getActiveShader())
 //     shader->activateShader();
-//   gluSphere(this->obj, 3, 10, 10);
+
+  this->getModel()->draw();
 //   shader->deactivateShader();
-//
-//
-// /*  if (this->model)
-//     this->model->draw();*/
-//   glPopMatrix();
+
+
+/*  if (this->model)
+    this->model->draw();*/
+  glPopMatrix();
 }
 
@@ -97,5 +119,5 @@
   //if (directin.len() < 100)
 //  this->shiftCoor(direction *dt * 5 * exp(-direction.len() / 30.0));
-  this->shiftDir(Quaternion(dt, this->randomRotAxis));
+//  this->shiftDir(Quaternion(dt, this->randomRotAxis));
 
 }
Index: trunk/src/world_entities/npcs/npc_test.h
===================================================================
--- trunk/src/world_entities/npcs/npc_test.h	(revision 9110)
+++ trunk/src/world_entities/npcs/npc_test.h	(revision 9235)
@@ -11,9 +11,12 @@
 
  public:
-  NPC2 ();
+  NPC2 (const TiXmlElement* root);
   virtual ~NPC2 ();
 
+  virtual void loadParams(const TiXmlElement* root);
 
   void addAI(AI* ai);
+
+  virtual void destroy(WorldEntity* killer);
 
   virtual void tick(float dt);
@@ -23,6 +26,4 @@
    Vector   randomRotAxis;
    Shader*  shader;
-   GLUquadricObj* obj;
-
 };
 
Index: trunk/src/world_entities/npcs/npc_test1.cc
===================================================================
--- trunk/src/world_entities/npcs/npc_test1.cc	(revision 9110)
+++ trunk/src/world_entities/npcs/npc_test1.cc	(revision 9235)
@@ -24,6 +24,4 @@
 #include "power_ups/turret_power_up.h"
 #include "power_ups/laser_power_up.h"
-
-using namespace std;
 
 
Index: trunk/src/world_entities/npcs/space_turret.cc
===================================================================
--- trunk/src/world_entities/npcs/space_turret.cc	(revision 9235)
+++ trunk/src/world_entities/npcs/space_turret.cc	(revision 9235)
@@ -0,0 +1,199 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Manuel Leuenberger
+   co-programmer: ...
+*/
+
+#include "space_turret.h"
+#include "model.h"
+#include "world_entities/weapons/turret.h"
+
+#include "state.h"
+#include "playable.h"
+#include "player.h"
+
+
+#include "util/loading/factory.h"
+#include "network_game_manager.h"
+#include "util/loading/load_param.h"
+
+#include "effects/explosion.h"
+
+CREATE_FACTORY(SpaceTurret, CL_SPACE_TURRET);
+
+/**
+ * constructs and loads a SpaceTurret from a XML-element
+ * @param root the XML-element to load from
+ */
+SpaceTurret::SpaceTurret(const TiXmlElement* root)
+  : NPC(root)
+{
+  this->init();
+  if (root != NULL)
+    this->loadParams(root);
+}
+
+
+/**
+ * standard deconstructor
+ */
+SpaceTurret::~SpaceTurret ()
+{
+
+}
+
+
+/**
+ * initializes the SpaceTurret
+ * @todo change this to what you wish
+ */
+void SpaceTurret::init()
+{
+  this->setClassID(CL_SPACE_TURRET, "SpaceTurret");
+  this->loadModel("models/ground_turret_#.obj", 7.5);
+  this->loadModel("models/comet.obj", 1.0f, 3);
+  this->left = NULL;
+  this->right = NULL;
+
+  this->setHealthMax(100);
+  this->setHealth(30);
+
+  this->weaponHolder[0].addNodeFlags(PNODE_PROHIBIT_DELETE_WITH_PARENT);
+  this->weaponHolder[1].addNodeFlags(PNODE_PROHIBIT_DELETE_WITH_PARENT);
+
+  this->weaponHolder[0].setRelCoor(0,25,0);
+  this->weaponHolder[0].setParent(this);
+  this->weaponHolder[1].setParent(this);
+}
+
+
+/**
+ * loads a SpaceTurret from a XML-element
+ * @param root the XML-element to load from
+ * @todo make the class Loadable
+ */
+void SpaceTurret::loadParams(const TiXmlElement* root)
+{
+  // all the clases this Entity is directly derived from must be called in this way, to load all settings.
+  NPC::loadParams(root);
+
+
+  /**
+   * @todo: make the class Loadable
+   */
+  const TiXmlElement* element;
+
+  element = root->FirstChildElement("weapon-left");
+  if (element != NULL) element = element->FirstChildElement();
+  this->left = dynamic_cast<Weapon*>( Factory::fabricate( element) );
+  if (this->left)
+  {
+    this->left->setParent(this);
+    this->left->toList(this->getOMListNumber());
+    this->left->setRelCoor(0,15,-7.5);
+    this->left->requestAction( WA_ACTIVATE);
+    this->left->setParent(&this->weaponHolder[0]);
+  }
+
+  element = root->FirstChildElement("weapon-right");
+  if (element != NULL)  if (element != NULL) element = element->FirstChildElement();
+  this->right = dynamic_cast<Weapon*>( Factory::fabricate( element) );
+  if (this->right)
+  {
+    this->right->setParent(this);
+    this->right->toList(this->getOMListNumber());
+    this->right->setRelCoor(0,15,7.5);
+    this->left->requestAction( WA_ACTIVATE);
+    this->right->setParent(&this->weaponHolder[0]);
+  }
+}
+
+/**
+ * advances the SpaceTurret about time seconds
+ * @param time the Time to step
+ */
+void SpaceTurret::tick(float dt)
+{
+  if(this->getHealth() > 0.0f && State::getPlayer() &&
+     State::getPlayer()->getPlayable() &&
+     State::getPlayer()->getPlayable()->distance(this) < 300) // HACK
+  {
+  if (likely(this->left != NULL))
+  {
+//    this->left->tickW(dt);
+    this->left->requestAction(WA_SHOOT);
+  }
+  if (likely(this->right != NULL))
+  {
+//    this->right->tickW(dt);
+    this->right->requestAction(WA_SHOOT);
+  }
+  }
+}
+
+/**
+ * draws this worldEntity
+ */
+void SpaceTurret::draw () const
+{
+  glPushMatrix();
+  glTranslatef (this->getAbsCoor ().x,
+                this->getAbsCoor ().y,
+                this->getAbsCoor ().z);
+
+  Vector tmpRot = this->getAbsDir().getSpacialAxis();
+  glRotatef (this->getAbsDir().getSpacialAxisAngle(), tmpRot.x, tmpRot.y, tmpRot.z );
+
+  this->getModel()->draw();
+  if (this->getModel() != NULL)
+    this->getModel(3)->draw();
+  glPopMatrix();
+/*
+  if (this->left != NULL)
+    this->left->draw();
+  if (this->right != NULL)
+    this->right->draw();*/
+}
+
+
+
+/**
+ *
+ *
+ */
+void SpaceTurret::postSpawn ()
+{
+
+}
+
+/**
+ *
+ *
+ */
+void SpaceTurret::leftWorld ()
+{
+
+}
+
+void SpaceTurret::destroy(WorldEntity* killer)
+{
+  this->setAbsDirSoft(Quaternion(-90, Vector(0,0,1)), 90);
+  Explosion::explode(this, Vector(10,10,10));
+
+  this->toList(OM_DEAD);
+
+  if (this->left)
+    this->left->toList(OM_DEAD);
+  if (this->right)
+    this->right->toList(OM_DEAD);
+
+}
Index: trunk/src/world_entities/npcs/space_turret.h
===================================================================
--- trunk/src/world_entities/npcs/space_turret.h	(revision 9235)
+++ trunk/src/world_entities/npcs/space_turret.h	(revision 9235)
@@ -0,0 +1,40 @@
+/*!
+ * @file space_turret.h
+ * @brief description
+*/
+
+#ifndef _SPACE_TURRET_H
+#define _SPACE_TURRET_H
+
+#include "npcs/npc.h"
+
+class Weapon;
+
+//! A Class to ...
+class SpaceTurret : public NPC
+{
+
+public:
+  SpaceTurret(const TiXmlElement* root = NULL);
+  virtual ~SpaceTurret();
+
+  virtual void loadParams(const TiXmlElement* root);
+
+  virtual void postSpawn ();
+  virtual void leftWorld ();
+
+  virtual void destroy(WorldEntity* killer);
+
+  virtual void draw() const;
+  virtual void tick(float time);
+
+private:
+  void init();
+
+
+private:
+  PNode  weaponHolder[2];
+  Weapon *left, *right;
+};
+
+#endif /* _SPACE_TURRET_H */
Index: trunk/src/world_entities/playable.cc
===================================================================
--- trunk/src/world_entities/playable.cc	(revision 9110)
+++ trunk/src/world_entities/playable.cc	(revision 9235)
@@ -67,6 +67,4 @@
   this->bDead = false;
 
-  //subscribe to collision reaction
-  this->subscribeReaction(CREngine::CR_PHYSICS_GROUND_WALK, CL_BSP_ENTITY);
 
   registerVar( new SynchronizeableInt( &score, &score, "score" ) );
@@ -393,5 +391,5 @@
   PRINTF(0)("Playable respawn\n");
   // only if this is the spaceship of the player
-  if( this == State::getPlayer()->getPlayable())
+  if( State::getGameRules() && State::getPlayer() && this == State::getPlayer()->getPlayable())
     State::getGameRules()->onPlayerSpawn();
 
@@ -403,9 +401,6 @@
 
 
-void Playable::destroy()
-{
-  Explosion::explode(dynamic_cast<PNode*>(this), Vector(1.0f, 1.0f, 1.0f));
-
-
+void Playable::destroy(WorldEntity* killer)
+{
   if( !this->bDead)
   {
@@ -416,13 +411,9 @@
       if( this == State::getPlayer()->getPlayable())
         State::getGameRules()->onPlayerDeath();
-
-      //     this->toList(OM_GROUP_05);
-      //HACK: moves the entity to an unknown place far far away: in the future, GameRules will look for that
-      this->setAbsCoor(-2000.0, -2000.0, -2000.0);
-
-      //explosion hack
-
     }
     this->bDead = true;
+    
+    if( State::getGameRules() != NULL)
+      State::getGameRules()->registerKill(Kill(killer, this));
   }
 }
Index: trunk/src/world_entities/playable.h
===================================================================
--- trunk/src/world_entities/playable.h	(revision 9110)
+++ trunk/src/world_entities/playable.h	(revision 9235)
@@ -80,5 +80,5 @@
 
   // WorldEntity Extensions
-  virtual void destroy();
+  virtual void destroy(WorldEntity* killer);
   virtual void respawn();
   virtual void collidesWith(WorldEntity* entity, const Vector& location);
@@ -90,4 +90,7 @@
   static const std::string& playmodeToString(Playable::Playmode playmode);
   static const std::string playmodeNames[];
+  
+  inline bool beFire(){ return this->bFire; }
+  inline void fire(bool bF){ this->bFire = bF;}
 
 protected:
Index: trunk/src/world_entities/projectiles/boomerang_projectile.cc
===================================================================
--- trunk/src/world_entities/projectiles/boomerang_projectile.cc	(revision 9235)
+++ trunk/src/world_entities/projectiles/boomerang_projectile.cc	(revision 9235)
@@ -0,0 +1,215 @@
+
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific
+   main-programmer: Silvan Nellen
+   co-programmer:
+
+*/
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WEAPON
+
+#include "boomerang_projectile.h"
+
+#include "state.h"
+#include "class_list.h"
+
+#include "dot_emitter.h"
+#include "sprite_particles.h"
+
+#include "debug.h"
+
+CREATE_FAST_FACTORY_STATIC(BoomerangProjectile, CL_BOOMERANG_PROJECTILE);
+
+/**
+ *  standard constructor
+*/
+BoomerangProjectile::BoomerangProjectile () : Projectile()
+{
+  this->setClassID(CL_BOOMERANG_PROJECTILE, "BoomerangProjectile");
+
+  this->loadModel("models/projectiles/orx-rocket.obj", 2.0);
+  this->loadExplosionSound("sound/explosions/explosion_4.wav");
+
+
+  this->setMinEnergy(1);
+  this->setHealthMax(10);
+  this->lifeSpan = 2.0;
+  this->agility = 3.5;
+  this->maxVelocity = 150;
+
+  this->emitter = new DotEmitter(100, 5, M_2_PI);
+  this->emitter->setParent(this);
+  this->emitter->setSpread(M_PI, M_PI);
+}
+
+
+/**
+ *  standard deconstructor
+*/
+BoomerangProjectile::~BoomerangProjectile ()
+{
+  // delete this->emitter;
+
+  /* this is normaly done by World.cc by deleting the ParticleEngine */
+  if (BoomerangProjectile::trailParticles != NULL && ClassList::getList(CL_BOOMERANG_PROJECTILE)->size() <= 1)
+  {
+    if (ClassList::exists(BoomerangProjectile::trailParticles, CL_PARTICLE_SYSTEM))
+      delete BoomerangProjectile::trailParticles;
+    BoomerangProjectile::trailParticles = NULL;
+  }
+  if (BoomerangProjectile::explosionParticles != NULL && ClassList::getList(CL_BOOMERANG_PROJECTILE)->size() <= 1)
+  {
+    if (ClassList::exists(BoomerangProjectile::explosionParticles, CL_PARTICLE_SYSTEM))
+      delete BoomerangProjectile::explosionParticles;
+    BoomerangProjectile::explosionParticles = NULL;
+  }
+
+}
+
+SpriteParticles* BoomerangProjectile::trailParticles = NULL;
+SpriteParticles* BoomerangProjectile::explosionParticles = NULL;
+
+
+
+void BoomerangProjectile::activate()
+{
+  if (unlikely(BoomerangProjectile::trailParticles == NULL))
+  {
+    BoomerangProjectile::trailParticles = new SpriteParticles(2000);
+    BoomerangProjectile::trailParticles->setName("BoomerangProjectileTrailParticles");
+    BoomerangProjectile::trailParticles->setMaterialTexture("maps/radial-trans-noise.png");
+    BoomerangProjectile::trailParticles->setLifeSpan(1.0, .3);
+    BoomerangProjectile::trailParticles->setRadius(0.0, .5);
+    BoomerangProjectile::trailParticles->setRadius(0.2, 4.0);
+    BoomerangProjectile::trailParticles->setRadius(.5, 1.5);
+    BoomerangProjectile::trailParticles->setRadius(1.0, 1.5);
+    BoomerangProjectile::trailParticles->setColor(0.0, 1,0,0,.7);
+    BoomerangProjectile::trailParticles->setColor(0.2, .8,.8,0,.5);
+    BoomerangProjectile::trailParticles->setColor(0.5, .8,.8,.8,.8);
+    BoomerangProjectile::trailParticles->setColor(1.0, .8,.8,.8,.0);
+  }
+  if (unlikely(BoomerangProjectile::explosionParticles == NULL))
+  {
+    BoomerangProjectile::explosionParticles = new SpriteParticles(200);
+    BoomerangProjectile::explosionParticles->setName("BoomerangProjectileExplosionParticles");
+    BoomerangProjectile::explosionParticles->setMaterialTexture("maps/radial-trans-noise.png");
+    BoomerangProjectile::explosionParticles->setLifeSpan(.5, .3);
+    BoomerangProjectile::explosionParticles->setRadius(0.0, 10);
+    BoomerangProjectile::explosionParticles->setRadius(.5, 15.0);
+    BoomerangProjectile::explosionParticles->setRadius(1.0, 10.0);
+    BoomerangProjectile::explosionParticles->setColor(0.0, 0,1,0,1);
+    BoomerangProjectile::explosionParticles->setColor(0.5, .8,.8,0,.8);
+    BoomerangProjectile::explosionParticles->setColor(0.8, .8,.8,.3,.8);
+    BoomerangProjectile::explosionParticles->setColor(1.0, 1,1,1,.0);
+  }
+
+  this->emitter->setSystem(BoomerangProjectile::trailParticles);
+
+  this->updateNode(0);
+  this->emitter->setEmissionRate(45.0);
+  this->emitter->setEmissionVelocity(0.0);
+
+  this->setHealth(10.0* (float)rand()/(float)RAND_MAX);
+}
+
+
+void BoomerangProjectile::deactivate()
+{
+  this->emitter->setSystem(NULL);
+  this->lifeCycle = 0.0;
+
+  this->toList(OM_DEAD);
+  this->removeNode();
+  BoomerangProjectile::fastFactory->kill(this);
+}
+
+
+void BoomerangProjectile::collidesWith(WorldEntity* entity, const Vector& location)
+{
+  if (this->hitEntity != entity)
+    this->destroy( entity );
+  this->hitEntity = entity;
+}
+
+/**
+ *  signal tick, time dependent things will be handled here
+ * @param time since last tick
+*/
+void BoomerangProjectile::tick (float time)
+{
+
+  Vector targetFarFarAway = this->getAbsCoor() + Vector(100000, 0, 0);
+
+  {
+    speed = velocity.len();
+    diffVector = ((targetFarFarAway - this->getAbsCoor()).getNormalized());
+
+    if(velocity.dot(diffVector) != 0)
+    {
+      correctionVector = (( ( diffVector *  (speed * speed/( velocity.dot(diffVector ) ) )) - velocity).getNormalized()) * agility;
+
+      if( (diffVector *  (speed * speed/( velocity.dot(diffVector ) ) ) -velocity).len() < agility )
+        velocity = ((diffVector *  (speed * speed/( velocity.dot(diffVector ) ) )).getNormalized())*agility;
+      else if(velocity.dot(diffVector) > 0)
+        velocity += correctionVector;
+      else if (velocity.dot(diffVector) < 0)
+        velocity -= correctionVector;
+    }
+    else
+      velocity += diffVector * agility;
+
+    this->setAbsDir(Quaternion(velocity, Vector(0,1,0)) * Quaternion ( -M_PI_2, Vector(0,1,0)));
+  }
+
+  velocity *= maxVelocity/velocity.len();
+  Vector v = this->velocity * (time);
+  this->shiftCoor(v);
+
+  if(this->tickLifeCycle(time))
+    this->deactivate();
+}
+
+/**
+ *  the function gets called, when the projectile is destroyed
+ */
+void BoomerangProjectile::destroy (WorldEntity* killer)
+{
+
+  printf("THIS SHOULD WORLk\n");
+
+  Projectile::destroy( killer );
+  PRINTF(5)("DESTROY BoomerangProjectile\n");
+  this->lifeCycle = .95; //!< @todo calculate this usefully.
+  this->emitter->setSystem(BoomerangProjectile::explosionParticles);
+
+  this->emitter->setEmissionRate(1000.0);
+  this->emitter->setEmissionVelocity(50.0);
+  //  this->deactivate();
+
+}
+
+
+void BoomerangProjectile::draw () const
+{
+  glMatrixMode(GL_MODELVIEW);
+  glPushMatrix();
+
+  float matrix[4][4];
+  glTranslatef (this->getAbsCoor ().x, this->getAbsCoor ().y, this->getAbsCoor ().z);
+  this->getAbsDir().matrix (matrix);
+  glMultMatrixf((float*)matrix);
+  glScalef(2.0, 2.0, 2.0);
+  this->getModel()->draw();
+
+  glPopMatrix();
+
+}
+
Index: trunk/src/world_entities/projectiles/boomerang_projectile.h
===================================================================
--- trunk/src/world_entities/projectiles/boomerang_projectile.h	(revision 9235)
+++ trunk/src/world_entities/projectiles/boomerang_projectile.h	(revision 9235)
@@ -0,0 +1,50 @@
+/*!
+ * @file boomerang_projectile.h
+ * @brief a BoomerangProjectile Projectile
+*/
+
+#ifndef _BOOMERANG_PROJECTILE_H
+#define _BOOMERANG_PROJECTILE_H
+
+#include "projectile.h"
+
+class Weapon;
+class SpriteParticles;
+class ParticleEmitter;
+class FastFactory;
+class Aim;
+
+class BoomerangProjectile : public Projectile
+{
+  public:
+    BoomerangProjectile ();
+    virtual ~BoomerangProjectile ();
+
+    virtual void activate();
+    virtual void deactivate();
+
+    virtual void collidesWith(WorldEntity* entity, const Vector& location);
+
+    virtual void destroy (WorldEntity* killer);
+
+    virtual void tick (float time);
+    virtual void draw () const;
+
+
+  private:
+    static FastFactory*               fastFactory;
+    static SpriteParticles*           trailParticles;
+    static SpriteParticles*           explosionParticles;
+
+    ParticleEmitter*                  emitter;
+    float                             agility;
+    float                             maxVelocity;
+    float                             speed;
+    Vector                            diffVector ;
+    Vector                            correctionVector;
+
+    WorldEntity* hitEntity; // FIXME TEMPORARY
+
+};
+
+#endif /* _BOOMERANG_PROJECTILE_H */
Index: trunk/src/world_entities/projectiles/guided_missile.cc
===================================================================
--- trunk/src/world_entities/projectiles/guided_missile.cc	(revision 9110)
+++ trunk/src/world_entities/projectiles/guided_missile.cc	(revision 9235)
@@ -35,5 +35,5 @@
   this->setClassID(CL_GUIDED_MISSILE, "GuidedMissile");
 
-  this->loadModel("models/projectiles/orx-rocket.obj", .3);
+  this->loadModel("models/projectiles/orx-rocket.obj", 2.0);
   this->loadExplosionSound("sound/explosions/explosion_4.wav");
 
@@ -88,7 +88,7 @@
     GuidedMissile::trailParticles->setLifeSpan(1.0, .3);
     GuidedMissile::trailParticles->setRadius(0.0, .5);
-    GuidedMissile::trailParticles->setRadius(0.2, 2.0);
-    GuidedMissile::trailParticles->setRadius(.5, .8);
-    GuidedMissile::trailParticles->setRadius(1.0, .8);
+    GuidedMissile::trailParticles->setRadius(0.2, 4.0);
+    GuidedMissile::trailParticles->setRadius(.5, 1.5);
+    GuidedMissile::trailParticles->setRadius(1.0, 1.5);
     GuidedMissile::trailParticles->setColor(0.0, 1,0,0,.7);
     GuidedMissile::trailParticles->setColor(0.2, .8,.8,0,.5);
@@ -135,5 +135,5 @@
 {
   if (this->hitEntity != entity)
-    this->destroy();
+    this->destroy( entity );
   this->hitEntity = entity;
 }
@@ -180,7 +180,10 @@
  *  the function gets called, when the projectile is destroyed
  */
-void GuidedMissile::destroy ()
-{
-  Projectile::destroy();
+void GuidedMissile::destroy (WorldEntity* killer)
+{
+
+  printf("THIS SHOULD WORLk\n");
+
+  Projectile::destroy( killer );
   PRINTF(5)("DESTROY GuidedMissile\n");
   this->lifeCycle = .95; //!< @todo calculate this usefully.
Index: trunk/src/world_entities/projectiles/guided_missile.h
===================================================================
--- trunk/src/world_entities/projectiles/guided_missile.h	(revision 9110)
+++ trunk/src/world_entities/projectiles/guided_missile.h	(revision 9235)
@@ -26,5 +26,5 @@
     virtual void collidesWith(WorldEntity* entity, const Vector& location);
 
-    virtual void destroy ();
+    virtual void destroy (WorldEntity* killer);
 
     virtual void tick (float time);
Index: trunk/src/world_entities/projectiles/hyperblast.cc
===================================================================
--- trunk/src/world_entities/projectiles/hyperblast.cc	(revision 9110)
+++ trunk/src/world_entities/projectiles/hyperblast.cc	(revision 9235)
@@ -126,7 +126,7 @@
  *  the function gets called, when the projectile is destroyed
 */
-void Hyperblast::destroy ()
+void Hyperblast::destroy (WorldEntity* killer)
 {
-  Projectile::destroy();
+  Projectile::destroy( killer );
 
   PRINTF(5)("DESTROY Hyperblast\n");
Index: trunk/src/world_entities/projectiles/hyperblast.h
===================================================================
--- trunk/src/world_entities/projectiles/hyperblast.h	(revision 9110)
+++ trunk/src/world_entities/projectiles/hyperblast.h	(revision 9235)
@@ -27,5 +27,5 @@
     virtual void collidesWith(WorldEntity* entity, const Vector& location);
 
-    virtual void destroy ();
+    virtual void destroy (WorldEntity* killer);
 
     virtual void tick (float time);
Index: trunk/src/world_entities/projectiles/laser.cc
===================================================================
--- trunk/src/world_entities/projectiles/laser.cc	(revision 9110)
+++ trunk/src/world_entities/projectiles/laser.cc	(revision 9235)
@@ -42,5 +42,5 @@
 
   this->setMinEnergy(10);
-  this->setHealthMax(10);
+  this->setHealthMax(0);
   this->lifeSpan = 5.0;
 
@@ -88,5 +88,6 @@
   }
 
-  this->setHealth(10);
+  this->setDamage(0);
+  this->setHealth(0);
 }
 
@@ -107,5 +108,5 @@
 {
   if (this->hitEntity != entity && entity->isA(CL_NPC))
-    this->destroy();
+    this->destroy( entity );
   this->hitEntity = entity;
 }
@@ -128,7 +129,7 @@
  *  the function gets called, when the projectile is destroyed
 */
-void Laser::destroy ()
+void Laser::destroy (WorldEntity* killer)
 {
-  Projectile::destroy();
+  Projectile::destroy( killer );
   PRINTF(5)("DESTROY Laser\n");
   this->lifeCycle = .95; //!< @todo calculate this usefully.
Index: trunk/src/world_entities/projectiles/laser.h
===================================================================
--- trunk/src/world_entities/projectiles/laser.h	(revision 9110)
+++ trunk/src/world_entities/projectiles/laser.h	(revision 9235)
@@ -27,5 +27,5 @@
     virtual void collidesWith(WorldEntity* entity, const Vector& location);
 
-    virtual void destroy ();
+    virtual void destroy (WorldEntity* killer);
 
     virtual void tick (float dt);
Index: trunk/src/world_entities/projectiles/projectile.cc
===================================================================
--- trunk/src/world_entities/projectiles/projectile.cc	(revision 9110)
+++ trunk/src/world_entities/projectiles/projectile.cc	(revision 9235)
@@ -41,5 +41,5 @@
   /* character attributes */
   this->setHealth(1.0f);
-  this->setDamage(100.0f); // default damage of a projectile set to 100.0 damage points
+  this->setDamage(1.0f); // default damage of a projectile set to 100.0 damage points
 
   this->explosionBuffer = NULL;
@@ -162,5 +162,5 @@
 
   if (this->tickLifeCycle(dt))
-    this->destroy();
+    this->destroy( NULL );
 }
 
@@ -169,5 +169,5 @@
  *  the function gets called, when the projectile is destroyed
 */
-void Projectile::destroy ()
+void Projectile::destroy (WorldEntity* killer)
 {
   if (this->explosionBuffer != NULL)
Index: trunk/src/world_entities/projectiles/projectile.h
===================================================================
--- trunk/src/world_entities/projectiles/projectile.h	(revision 9110)
+++ trunk/src/world_entities/projectiles/projectile.h	(revision 9235)
@@ -41,5 +41,5 @@
     virtual void deactivate() = 0;
 
-    virtual void destroy ();
+    virtual void destroy (WorldEntity* killer);
 
     virtual void tick (float dt);
Index: trunk/src/world_entities/projectiles/rail_projectile.cc
===================================================================
--- trunk/src/world_entities/projectiles/rail_projectile.cc	(revision 9235)
+++ trunk/src/world_entities/projectiles/rail_projectile.cc	(revision 9235)
@@ -0,0 +1,159 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific
+   main-programmer: Patrick Boenzli
+   co-programmer: Benjamin Grauer
+
+*/
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WEAPON
+
+#include "rail_projectile.h"
+
+#include "state.h"
+#include "class_list.h"
+#include "model.h"
+
+#include "dot_emitter.h"
+#include "sprite_particles.h"
+
+#include <cassert>
+#include "debug.h"
+
+using namespace std;
+
+CREATE_FAST_FACTORY_STATIC(RailProjectile, CL_RAIL_PROJECTILE);
+
+/**
+ *  standard constructor
+*/
+RailProjectile::RailProjectile () : Projectile()
+{
+  this->setClassID(CL_RAIL_PROJECTILE, "RailProjectile");
+
+  this->loadModel("models/projectiles/laser_projectile.obj", 100);
+
+  this->setMinEnergy(10);
+  this->setHealthMax(10);
+  this->lifeSpan = .5f;
+
+  this->emitter = new DotEmitter(100, 5, M_2_PI);
+  this->emitter->setParent(this);
+  this->emitter->setSpread(M_PI, M_PI);
+  this->emitter->setEmissionRate(300.0);
+  this->emitter->setEmissionVelocity(50.0);
+}
+
+
+/**
+ *  standard deconstructor
+*/
+RailProjectile::~RailProjectile ()
+{
+  // delete this->emitter;
+
+  /* this is normaly done by World.cc by deleting the ParticleEngine */
+  if (RailProjectile::explosionParticles != NULL && ClassList::getList(CL_RAIL_PROJECTILE)->size() <= 1)
+  {
+    //if (ClassList::exists(RailProjectile::explosionParticles, CL_PARTICLE_SYSTEM))
+    //  delete RailProjectile::explosionParticles;
+    PRINTF(1)("Deleting RailProjectile Particles\n");
+    RailProjectile::explosionParticles = NULL;
+  }
+
+}
+
+SpriteParticles* RailProjectile::explosionParticles = NULL;
+
+void RailProjectile::activate()
+{
+  if (unlikely(RailProjectile::explosionParticles == NULL))
+  {
+    RailProjectile::explosionParticles = new SpriteParticles(1000);
+    RailProjectile::explosionParticles->setName("RailProjectileExplosionParticles");
+    RailProjectile::explosionParticles->setLifeSpan(.5, .3);
+    RailProjectile::explosionParticles->setRadius(0.0, 10.0);
+    RailProjectile::explosionParticles->setRadius(.5, 6.0);
+    RailProjectile::explosionParticles->setRadius(1.0, 3.0);
+    RailProjectile::explosionParticles->setColor(0.0, 1,1,0,.9);
+    RailProjectile::explosionParticles->setColor(0.5, .8,.8,0,.5);
+    RailProjectile::explosionParticles->setColor(1.0, .8,.8,.7,.0);
+  }
+
+  this->setHealth(10);
+}
+
+
+void RailProjectile::deactivate()
+{
+  assert (RailProjectile::explosionParticles != NULL);
+  RailProjectile::explosionParticles->removeEmitter(this->emitter);
+  this->lifeCycle = 0.0;
+
+  this->toList(OM_NULL);
+  this->removeNode();
+  RailProjectile::fastFactory->kill(this);
+}
+
+
+void RailProjectile::collidesWith(WorldEntity* entity, const Vector& location)
+{
+  if (this->hitEntity != entity && entity->isA(CL_NPC))
+    this->destroy( entity );
+  this->hitEntity = entity;
+}
+
+/**
+ *  signal tick, time dependent things will be handled here
+ * @param dt time since last tick
+*/
+void RailProjectile::tick (float dt)
+{
+  //Vector v = *this->flightDirection * ( this->speed * time * 1000 + 0.1);
+  Vector v = this->velocity * dt;
+  this->shiftCoor(v);
+
+  if (this->tickLifeCycle(dt))
+    this->deactivate();
+}
+
+/**
+ *  the function gets called, when the projectile is destroyed
+*/
+void RailProjectile::destroy (WorldEntity* killer)
+{
+  Projectile::destroy( killer );
+  PRINTF(5)("DESTROY RailProjectile\n");
+  this->lifeCycle = .95; //!< @todo calculate this usefully.
+
+  this->emitter->setSystem(RailProjectile::explosionParticles);
+}
+
+
+void RailProjectile::draw () const
+{
+  glPushAttrib(GL_ENABLE_BIT);
+  glDisable(GL_LIGHTING);
+
+  WorldEntity::draw();
+/*  glMatrixMode(GL_MODELVIEW);
+  glPushMatrix();
+
+  float matrix[4][4];
+  glTranslatef (this->getAbsCoor ().x, this->getAbsCoor ().y, this->getAbsCoor ().z);
+  this->getAbsDir().matrix (matrix);
+  glMultMatrixf((float*)matrix);
+  glScalef(2.0, 2.0, 2.0);
+  this->getModel()->draw();
+  glPopMatrix();*/
+
+  glPopAttrib();
+}
+
